"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireDefault(require("react"));

var _icon = _interopRequireDefault(require("../components/icon"));

/* dts-imports
import { Icon } from 'zmp-core/types';
*/

/* dts-props
  id: string | number;
  className: string;
  style: React.CSSProperties;
  zmp? : Icon.IconZMP;
  tooltip? : string;
  tooltipTrigger? : string;
  size? : string | number;
  onClick? : (event?: any) => void;
  COLOR_PROPS
  ref?: React.MutableRefObject<{el: HTMLElement | null}>;
  CHILDREN_PROP
*/
var icons = {
  zi_add_member: 'zi_add_member',
  zi_add_member_solid: 'zi_add_member_solid',
  zi_add_user: 'zi_add_user',
  zi_add_user_solid: 'zi_add_user_solid',
  zi_admin: 'zi_admin',
  zi_create_group: 'zi_create_group',
  zi_create_group_solid: 'zi_create_group_solid',
  zi_group: 'zi_group',
  zi_group_solid: 'zi_group_solid',
  zi_members: 'zi_members',
  zi_members_solid: 'zi_members_solid',
  zi_stranger: 'zi_stranger',
  zi_stranger_solid: 'zi_stranger_solid',
  zi_switch_users: 'zi_switch_users',
  zi_switch_users_solid: 'zi_switch_users_solid',
  zi_user: 'zi_user',
  zi_user_check: 'zi_user_check',
  zi_user_circle: 'zi_user_circle',
  zi_user_circle_solid: 'zi_user_circle_solid',
  zi_user_search: 'zi_user_search',
  zi_user_search_solid: 'zi_user_search_solid',
  zi_user_settings: 'zi_user_settings',
  zi_user_settings_solid: 'zi_user_settings_solid',
  zi_user_solid: 'zi_user_solid',
  zi_add_photo: 'zi_add_photo',
  zi_camera: 'zi_camera',
  zi_gallery: 'zi_gallery',
  zi_link: 'zi_link',
  zi_livestream: 'zi_livestream',
  zi_pause: 'zi_pause',
  zi_pause_solid: 'zi_pause_solid',
  zi_photo: 'zi_photo',
  zi_photo_search: 'zi_photo_search',
  zi_photo_solid: 'zi_photo_solid',
  zi_play: 'zi_play',
  zi_play_solid: 'zi_play_solid',
  zi_add_story: 'zi_add_story',
  zi_ban: 'zi_ban',
  zi_bullet_solid: 'zi_bullet_solid',
  zi_check: 'zi_check',
  zi_check_circle: 'zi_check_circle',
  zi_check_circle_solid: 'zi_check_circle_solid',
  zi_close: 'zi_close',
  zi_close_circle: 'zi_close_circle',
  zi_close_circle_solid: 'zi_close_circle_solid',
  zi_copy: 'zi_copy',
  zi_delete: 'zi_delete',
  zi_drag_indicator_solid: 'zi_drag_indicator_solid',
  zi_filter: 'zi_filter',
  zi_filter_solid: 'zi_filter_solid',
  zi_home: 'zi_home',
  zi_leave: 'zi_leave',
  zi_leave_solid: 'zi_leave_solid',
  zi_list_1: 'zi_list_1',
  zi_list_2: 'zi_list_2',
  zi_minus_circle: 'zi_minus_circle',
  zi_minus_circle_solid: 'zi_minus_circle_solid',
  zi_more_diamond_solid: 'zi_more_diamond_solid',
  zi_more_grid: 'zi_more_grid',
  zi_more_grid_solid: 'zi_more_grid_solid',
  zi_more_horiz: 'zi_more_horiz',
  zi_more_horiz_solid: 'zi_more_horiz_solid',
  zi_more_vert: 'zi_more_vert',
  zi_plus: 'zi_plus',
  zi_plus_circle: 'zi_plus_circle',
  zi_plus_circle_solid: 'zi_plus_circle_solid',
  zi_radio_checked: 'zi_radio_checked',
  zi_radio_unchecked: 'zi_radio_unchecked',
  zi_save_to_collection: 'zi_save_to_collection',
  zi_search: 'zi_search',
  zi_setting: 'zi_setting',
  zi_tune: 'zi_tune',
  zi_arrow_down: 'zi_arrow_down',
  zi_arrow_left: 'zi_arrow_left',
  zi_arrow_right: 'zi_arrow_right',
  zi_arrow_up: 'zi_arrow_up',
  zi_auto: 'zi_auto',
  zi_auto_solid: 'zi_auto_solid',
  zi_backup_arrow_solid: 'zi_backup_arrow_solid',
  zi_chevron_double_down: 'zi_chevron_double_down',
  zi_chevron_double_up: 'zi_chevron_double_up',
  zi_chevron_down: 'zi_chevron_down',
  zi_chevron_left: 'zi_chevron_left',
  zi_chevron_left_header: 'zi_chevron_left_header',
  zi_chevron_right: 'zi_chevron_right',
  zi_chevron_up: 'zi_chevron_up',
  zi_download: 'zi_download',
  zi_download_solid: 'zi_download_solid',
  zi_reorder_solid: 'zi_reorder_solid',
  zi_reply: 'zi_reply',
  zi_reply_solid: 'zi_reply_solid',
  zi_retry: 'zi_retry',
  zi_retry_solid: 'zi_retry_solid',
  zi_share: 'zi_share',
  zi_share_external_1: 'zi_share_external_1',
  zi_share_external_2: 'zi_share_external_2',
  zi_share_solid: 'zi_share_solid',
  zi_unfold_less: 'zi_unfold_less',
  zi_unfold_more: 'zi_unfold_more',
  zi_upload: 'zi_upload',
  zi_at: 'zi_at',
  zi_bubble_multiselect: 'zi_bubble_multiselect',
  zi_call: 'zi_call',
  zi_call_solid: 'zi_call_solid',
  zi_chat: 'zi_chat',
  zi_chat_solid: 'zi_chat_solid',
  zi_grid_solid: 'zi_grid_solid',
  zi_location: 'zi_location',
  zi_location_solid: 'zi_location_solid',
  zi_mic: 'zi_mic',
  zi_quote: 'zi_quote',
  zi_quote_solid: 'zi_quote_solid',
  zi_recall: 'zi_recall',
  zi_send_solid: 'zi_send_solid',
  zi_user_window_solid: 'zi_user_window_solid',
  zi_video: 'zi_video',
  zi_video_group: 'zi_video_group',
  zi_video_solid: 'zi_video_solid',
  zi_wifi: 'zi_wifi',
  zi_wifi_off: 'zi_wifi_off',
  zi_backup_solid: 'zi_backup_solid',
  zi_backup_success_solid: 'zi_backup_success_solid',
  zi_backup_warning_solid: 'zi_backup_warning_solid',
  zi_bookmark: 'zi_bookmark',
  zi_bookmark_delete: 'zi_bookmark_delete',
  zi_favorite_list: 'zi_favorite_list',
  zi_heart: 'zi_heart',
  zi_heart_solid: 'zi_heart_solid',
  zi_pin: 'zi_pin',
  zi_pin_solid: 'zi_pin_solid',
  zi_star: 'zi_star',
  zi_star_solid: 'zi_star_solid',
  zi_unpin: 'zi_unpin',
  zi_calendar: 'zi_calendar',
  zi_calendar_solid: 'zi_calendar_solid',
  zi_clock_1: 'zi_clock_1',
  zi_clock_1_solid: 'zi_clock_1_solid',
  zi_clock_2: 'zi_clock_2',
  zi_clock_2_solid: 'zi_clock_2_solid',
  zi_memory: 'zi_memory',
  zi_reminder: 'zi_reminder',
  zi_reminder_delete: 'zi_reminder_delete',
  zi_reminder_solid: 'zi_reminder_solid',
  zi_edit: 'zi_edit',
  zi_edit_delete: 'zi_edit_delete',
  zi_edit_delete_solid: 'zi_edit_delete_solid',
  zi_edit_solid: 'zi_edit_solid',
  zi_edit_text: 'zi_edit_text',
  zi_edit_text_solid: 'zi_edit_text_solid',
  zi_post: 'zi_post',
  zi_exclamation: 'zi_exclamation',
  zi_help_circle: 'zi_help_circle',
  zi_info_circle: 'zi_info_circle',
  zi_info_circle_solid: 'zi_info_circle_solid',
  zi_warning: 'zi_warning',
  zi_warning_circle: 'zi_warning_circle',
  zi_warning_circle_solid: 'zi_warning_circle_solid',
  zi_warning_solid: 'zi_warning_solid',
  zi_file: 'zi_file',
  zi_inbox: 'zi_inbox',
  zi_note: 'zi_note',
  zi_note_delete: 'zi_note_delete',
  zi_pcline: 'zi_pcline',
  zi_poll: 'zi_poll',
  zi_poll_solid: 'zi_poll_solid',
  zi_qrline: 'zi_qrline',
  zi_truyen_file: 'zi_truyen_file',
  zi_wallpaper: 'zi_wallpaper',
  zi_hide: 'zi_hide',
  zi_key_solid: 'zi_key_solid',
  zi_lock: 'zi_lock',
  zi_lock_open_solid: 'zi_lock_open_solid',
  zi_lock_solid: 'zi_lock_solid',
  zi_notif: 'zi_notif',
  zi_notif_off: 'zi_notif_off',
  zi_notif_off_solid: 'zi_notif_off_solid',
  zi_notif_ring: 'zi_notif_ring',
  zi_shield_solid: 'zi_shield_solid',
  zi_unhide: 'zi_unhide',
  zi_unlock: 'zi_unlock',
  zi_unlock_solid: 'zi_unlock_solid'
};

var ZMPIcon = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var zmp = props.zmp,
      children = props.children,
      rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["zmp", "children"]);

  var getIcon = function getIcon(iconStr) {
    if (typeof iconStr === 'string') {
      var iconKey = iconStr.replace(/-/g, '_');
      var _iconContent = icons[iconKey];
      return _iconContent || null;
    }

    return null;
  };

  var iconContent = getIcon(zmp || children);
  return /*#__PURE__*/_react.default.createElement(_icon.default, (0, _extends2.default)({}, rest, {
    zmp: iconContent,
    ref: ref
  }));
});

ZMPIcon.displayName = 'zmp-icon';
var _default = ZMPIcon;
exports.default = _default;